

# Introducton To HTTP

For this comminucation to occur there must a set of rules agreed upon between  client and server.For instance in Kenya we have agreed to officially speak english or swahili.This set of rules or protocols to be followed in what is known as http(hypertext tranfer protocol).

Http is a protocol used govern communication in the internet.

Communication is generally defined as tranfer of information from on point to another.

Client(your local computer) makes the request and the server a dedicated computer, dedication in this we can say it is on 24/7.




## Understanding HTTP



The http has evolved as everything should which given rise to **https** the s in https simply mean secure.This came up due security issue.The tranfer of every data in http in done in plain-text(without encryption), encryption is 
fancy to mean the data you sending is only understood by the sender(client) 
and the receiver.
Therefore https = http + s

So how is  the done securing, well ever tried go to a website and in your browser you see something SSL or TLS, the messages is usually longer than that
but those acronym are our point of interest.

More on TLS and SSL and http - [check this](https://howhttps.works/why-do-we-need-https/) 

## The request-response cycle 

Back and forth flow of information is what is know has **request response cycles**.That client in most cases browser make a request and on process request server gives the appropriate feedback.

These http request and response are ussually stateless.That is to say the once the cycle is complete that the client get the response after request, the cycle
is forgetten.

The state is ussually  stored in the serve if need be ussually in a file or database for future reference.

![htp cycle](./img/httpcycle.png)


